## org.eclipse.ocl.lpg
Interface BasicEnvironment2

All Superinterfaces:
  Adaptable, BasicEnvironment, Customizable

All Known Implementing Classes:
  AbstractBasicEnvironment, AbstractEnvironment, CompatibilityEnvironment, EcoreEnvironment

    public interface BasicEnvironment2

extends BasicEnvironment

A `BasicEnvironment2` provides an extended environment interface to support asymmetric as well as symmetric mappings between CST and AST.

Since:
  1.3

Method Summary
`void` `initASTMapping(Object fromAstNode, CSTNode cstNode, Object toAstNode)` Initialize the asymmetric mapping of an object (typically an astNode) to its originating cstNode, and of a cstNode to its consequent object (typically an astNode) so that AST-based analysis may report error messages exploiting the CST context, or to support incremental AST/CST update.

Methods inherited from interface org.eclipse.ocl.lpg.BasicEnvironment
`analyzerError, analyzerError, analyzerError, analyzerWarning, getASTMapping, getFormatter, getParser, getProblemHandler, initASTMapping, lexerError, parserError, problem, setParser, setProblemHandler, utilityError, validatorError`

Methods inherited from interface org.eclipse.ocl.util.Adaptable
`getAdapter`

Methods inherited from interface org.eclipse.ocl.options.Customizable
`clearOptions, getOptions, getValue, isEnabled, putOptions, removeOption, removeOptions, setOption`

Method Detail

### initASTMapping

    void initASTMapping(Object fromAstNode,
                        CSTNode cstNode,
                        Object toAstNode)

  Initialize the asymmetric mapping of an object (typically an astNode) to its originating cstNode, and of a cstNode to its consequent object (typically an astNode) so that AST-based analysis may report error messages exploiting the CST context, or to support incremental AST/CST update. Any pre-existing mapping is preserved. Each mapping involving a null object is ignored, so that for instance the toAstNode may be set null to establish only the fromAstNode to cstNode mapping.

  Parameters:
    `fromAstNode` - source of the AST-to-CST mapping
    `cstNode` - target of the AST-to-CST mapping and source of the CST-to-AST mapping
    `toAstNode` - target of the CST-to-AST mapping

Copyright 2002, 2007 IBM Corporation and others. All Rights Reserved.